/*!
 * --------------------------------------------------------------
 * Amazon Pay  V3.1.0
 * static.js 2017-02-10
 *
 * alkim media
 * http://www.alkim.de
 *
 * patworx multimedia GmbH
 * http://www.patworx.de/
 *
 * Released under the GNU General Public License
 * --------------------------------------------------------------
 */
var AmAmazonLoginAndPay = {
    buyProduct: function($triggerEl, callback) {
        var form = $triggerEl.closest('form');
        var url = form.attr('action');
        var t = url.split('?');
        var qs = '';
        if (t[1]) {
            qs = t[1];
        }
        if (qs) {
            var connector = (amapa.baseUrl.indexOf('?') == -1 ? '?' : '&');
        }
        if ($('.amzWaitingImage').length == 0) {
            $triggerEl.replaceWith(amapa.waitingImage);
        }
        $.post(amapa.baseUrl + connector + qs, form.serialize(), function() {
            callback();
        })
    },
    beforeCheckoutAjaxCall: function() {
        $('#amazon_button').css('visibility', 'hidden');
        if (showCheckoutButtonTimeout) {
            clearTimeout(showCheckoutButtonTimeout);
        }
    }
};

function disableAmzWidget(wrObj) {
    if (wrObj.length > 0) {
        var width = wrObj.width();
        var height = wrObj.height();
        var offset = wrObj.offset();
        var blocker = $('<div style="width:' + width + 'px; height:' + height + 'px; position:absolute; top:' + offset.top + 'px;  left:' + offset.left + 'px; background:#fff; opacity: 0.5; z-index:1000;">&nbsp;</div>');
        $('body').append(blocker);
    }
}

function amzPopupWindow(url) {
    window.open(url, 'popupWindow', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,copyhistory=no,width=400,height=600,screenX=150,screenY=150,top=150,left=150')
}

function getURLParameter(name, source) {
    return decodeURIComponent((new RegExp('[?|&|#]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(source) || [, ""])[1].replace(/\+/g, '%20')) || null;
}

function amazonLogout() {
    if (typeof(amazon) != 'undefined') {
        amazon.Login.logout();
    }
    document.cookie = "amazon_Login_accessToken=; expires=Thu, 01 Jan 1970 00:00:00 GMT";
}

function amzSetCookie(cname, cvalue) {
    var d = new Date();
    d.setTime(d.getTime() + 180000);
    var expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires + "; path=/; secure";
}

function initAmazonPaymentsMaster() {
    initAmazon();
    if (typeof(initCheckoutAmazon) != 'undefined') {
        initCheckoutAmazon();
    }
    if (typeof(initCheckoutAmazonSetAdress) != 'undefined') {
        initCheckoutAmazonSetAdress();
    }
    if (typeof(initCheckoutAmazonWallet) != 'undefined') {
        initCheckoutAmazonWallet();
    }
}

$(document).ready(function() {
    if ($('#amazon_checkout_button_placehholder').length > 0) {
        var os = $('#amazon_checkout_button_placehholder').offset();
        var os2 = $('#payWithAmazonDiv').offset();
        $('#payWithAmazonDiv').css({
            position: 'relative',
            top: (os.top - os2.top) + 'px'
        });
    }
    amapa.isDocumentReady = true;
    if (amapa.isAmazonPaymentsReady) {
        initAmazonPaymentsMaster();
    }

    $('.buyProductWithAmazonButton').click(function(e) {
        e.preventDefault();
        if (amapa.isRedirect) {
            AmAmazonLoginAndPay.buyProduct($(this), function() {
                $('#payWithAmazonDiv > img').click();
            });
        } else {
            $('#payWithAmazonDiv > img').click();
        }

    });

    $('#logoff_link, a[href*="logoff.php"]').click(function() {
        amazonLogout();
    });
});

