<?php
/* --------------------------------------------------------------
   Amazon Pay  V3.1.0

   alkim media
   http://www.alkim.de
   patworx multimedia GmbH
   http://www.patworx.de/

Released under the GNU General Public License
--------------------------------------------------------------
*/

class AMZxtcPrice extends AMZxtcPrice_parent {

	public function __construct($p_currency_code, $p_customers_status_id)
	{
		$this->dataCache = DataCache::get_instance();

		$this->actualGroup = $p_customers_status_id;
		$this->actualCurr = $p_currency_code;
		$this->v_coo_language_text_manager = MainFactory::create_object('LanguageTextManager', array('price', $_SESSION['languages_id']));

		// select Currencies
		$t_sql = 'SELECT * FROM ' . TABLE_CURRENCIES;
		$t_result = xtc_db_query($t_sql);

		while($currencies = xtc_db_fetch_array($t_result))
		{
			$this->currencies[$currencies['code']] = array('title' => $currencies['title'],
															'symbol_left' => $currencies['symbol_left'],
															'symbol_right' => $currencies['symbol_right'],
															'decimal_point' => $currencies['decimal_point'],
															'thousands_point' => $currencies['thousands_point'],
															'decimal_places' => $currencies['decimal_places'],
															'value' => $currencies['value']);
		}

		// select Customers Status data
		$t_sql = "SELECT * FROM " . TABLE_CUSTOMERS_STATUS . "
					WHERE
						customers_status_id = '" . $this->actualGroup . "' AND
						language_id = '" . $_SESSION['languages_id'] . "'";
		$t_result = xtc_db_query($t_sql);
		$t_customers_status_array = xtc_db_fetch_array($t_result);
		$this->cStatus = array('customers_status_id' => $this->actualGroup,
								'customers_status_name' => $t_customers_status_array['customers_status_name'],
								'customers_status_image' => $t_customers_status_array['customers_status_image'],
								'customers_status_public' => $t_customers_status_array['customers_status_public'],
								'customers_status_discount' => $t_customers_status_array['customers_status_discount'],
								'customers_status_ot_discount_flag' => $t_customers_status_array['customers_status_ot_discount_flag'],
								'customers_status_ot_discount' => $t_customers_status_array['customers_status_ot_discount'],
								'customers_status_graduated_prices' => $t_customers_status_array['customers_status_graduated_prices'],
								'customers_status_show_price' => $t_customers_status_array['customers_status_show_price'],
								'customers_status_show_price_tax' => $t_customers_status_array['customers_status_show_price_tax'],
								'customers_status_add_tax_ot' => $t_customers_status_array['customers_status_add_tax_ot'],
								'customers_status_payment_unallowed' => $t_customers_status_array['customers_status_payment_unallowed'],
								'customers_status_shipping_unallowed' => $t_customers_status_array['customers_status_shipping_unallowed'],
								'customers_status_discount_attributes' => $t_customers_status_array['customers_status_discount_attributes'],
								'customers_fsk18' => $t_customers_status_array['customers_fsk18'],
								'customers_fsk18_display' => $t_customers_status_array['customers_fsk18_display']);

		// prefetch tax rates for standard zone
		$t_sql = 'SELECT tax_class_id AS class FROM ' . TABLE_TAX_CLASS;
		$t_result = xtc_db_query($t_sql);

		while($t_zones_array = xtc_db_fetch_array($t_result))
		{
			// calculate tax based on shipping or deliverey country (for downloads)
			if(isset($_SESSION['billto']) && isset($_SESSION['sendto']))
			{
				$t_content_type = null;

				if(isset($_SESSION['cart']) && method_exists($_SESSION['cart'], 'get_content_type'))
				{
					$t_content_type = $_SESSION['cart']->get_content_type();
				}

				$t_sql = "SELECT
								ab.entry_country_id,
								ab.entry_zone_id
							FROM " . TABLE_ADDRESS_BOOK . " ab
							LEFT JOIN " . TABLE_ZONES . " z ON (ab.entry_zone_id = z.zone_id)
							WHERE
								ab.customers_id = '" . $_SESSION['customer_id'] . "' AND
								ab.address_book_id = '" . ($t_content_type == 'virtual' ? xtc_db_input($_SESSION['billto']) : xtc_db_input($_SESSION['sendto'])) . "'";
				$t_address_result = xtc_db_query($t_sql);
				$t_address_array = xtc_db_fetch_array($t_address_result);
				$this->TAX[$t_zones_array['class']] = xtc_get_tax_rate($t_zones_array['class'], $t_address_array['entry_country_id'], $t_address_array['entry_zone_id']);
			}# BOM AMAZON PAYMENTS POWERED BY ALKIM MEDIA
			elseif (!$this->TAX[$zones_data['class']] && isset($_SESSION['AMZ_COUNTRY_ID']) && isset($_SESSION['AMZ_ZONE_ID']))
			{
				$tax_address = array('entry_country_id' => $_SESSION['AMZ_COUNTRY_ID'], 'entry_zone_id' => $_SESSION['AMZ_ZONE_ID']);
				$this->TAX[$t_zones_array['class']]=xtc_get_tax_rate($t_zones_array['class'],$tax_address['entry_country_id'], $tax_address['entry_zone_id']);
			}# EOM AMAZON PAYMENTS POWERED BY ALKIM MEDIA
			elseif(!isset($_SESSION['customer_id']))
			{
				$t_customer_country_id = (isset($_SESSION['customer_country_id'])) ? (int)$_SESSION['customer_country_id'] : -1;

				$this->TAX[$t_zones_array['class']] = xtc_get_tax_rate($t_zones_array['class'], $t_customer_country_id);
			}
			else
			{
				$this->TAX[$t_zones_array['class']] = xtc_get_tax_rate($t_zones_array['class']);
			}
			
			
		}
	}

}

